function [p]=priorehl(Theta)

% uniform priors for 7 parameters
cte1=log(0.98);
cte2=log(0.4);

p=0;

if Theta(7)>=0 & Theta(7)<=0.98  %Interest Rate Smoothing in Taylor rule
   p=p-cte1;
else
   p=-Inf;
   return;
end
if Theta(10)>=0 & Theta(10)<=0.98  % autocorrelation of technology shocks
   p=p-cte1;
else
   p=-Inf;
   return;
end
if Theta(11)>=0 & Theta(11)<=0.98  % autocorrelation of preference shocks
   p=p-cte1;
else
   p=-Inf;
   return;
end
if Theta(12)>=0 & Theta(12)<=0.4  % 
   p=p-cte2;
else
   p=-Inf;
   return;
end
if Theta(13)>=0 & Theta(13)<=0.4  % 
   p=p-cte2;
else
   p=-Inf;
   return;
end
if Theta(14)>=0 & Theta(14)<=0.4  % 
   p=p-cte2;
else
   p=-Inf;
   return;
end
if Theta(15)>=0 & Theta(15)<=0.4  % 
   p=p-cte2;
else
   p=-Inf;
   return;
end

% informative priors for the rest

p=log(gampdf(1/Theta(1),2,1.25))+p; % elasticity of substitution...mu=alfa*beta=2*1 sigma^2=alfa*beta^2=2*1^2
p=log(gampdf(1/(1-Theta(2))-1,2,1))+p; % duration of prices
p=log(gampdf(1/(1-Theta(3))-1,3,1))+p; % duration of wages
p=log(normpdf(Theta(4),1,1/2))+p; % inverse elasticity labor supply
%p=log(gampdf(Theta(5)-1,3.33,1.5))+p; % elasticity of labor demand
% no Theta(6)				% NO RULE OF THUMB BEHAVIOR
p=log(normpdf(Theta(8),1/8,1/8))+p; %Coefficents in Taylor rule: output
p=log(normpdf(Theta(9),1.5,1/4))+p; %Coefficents in Taylor rule: price
